/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGAffineTransform;

import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGGeometry;


extern (C)
{
	extern
	{
		const CGAffineTransform CGAffineTransformIdentity;
	}
}

struct CGAffineTransform
{
	CGFloat a;
	CGFloat b;
	CGFloat c;
	CGFloat d;
	CGFloat tx;
	CGFloat ty;
}

extern (C)
{
	CGAffineTransform CGAffineTransformMake (CGFloat a, CGFloat b, CGFloat c, CGFloat d, CGFloat tx, CGFloat ty);
	CGAffineTransform CGAffineTransformMakeTranslation (CGFloat tx, CGFloat ty);
	CGAffineTransform CGAffineTransformMakeScale (CGFloat sx, CGFloat sy);
	CGAffineTransform CGAffineTransformMakeRotation (CGFloat angle);
	bool CGAffineTransformIsIdentity (CGAffineTransform t);
	CGAffineTransform CGAffineTransformTranslate (CGAffineTransform t, CGFloat tx, CGFloat ty);
	CGAffineTransform CGAffineTransformScale (CGAffineTransform t, CGFloat sx, CGFloat sy);
	CGAffineTransform CGAffineTransformRotate (CGAffineTransform t, CGFloat angle);
	CGAffineTransform CGAffineTransformInvert (CGAffineTransform t);
	CGAffineTransform CGAffineTransformConcat (CGAffineTransform t1, CGAffineTransform t2);
	bool CGAffineTransformEqualToTransform (CGAffineTransform t1, CGAffineTransform t2);
	CGPoint CGPointApplyAffineTransform (CGPoint point, CGAffineTransform t);
	CGSize CGSizeApplyAffineTransform (CGSize size, CGAffineTransform t);
	CGRect CGRectApplyAffineTransform (CGRect rect, CGAffineTransform t);
}