/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGPDFObject;

import dstep.applicationservices.coregraphics.CGBase;

union CGPDFObject;

alias ubyte CGPDFBoolean;
alias int CGPDFInteger;
alias CGFloat CGPDFReal;
alias CGPDFObject* CGPDFObjectRef;
alias int CGPDFObjectType;

enum /*CGPDFObjectType*/ 
{
	kCGPDFObjectTypeNull = 1,
	kCGPDFObjectTypeBoolean,
	kCGPDFObjectTypeInteger,
	kCGPDFObjectTypeReal,
	kCGPDFObjectTypeName,
	kCGPDFObjectTypeString,
	kCGPDFObjectTypeArray,
	kCGPDFObjectTypeDictionary,
	kCGPDFObjectTypeStream
}

extern (C)
{
	int CGPDFObjectGetType (CGPDFObjectRef object);
	bool CGPDFObjectGetValue (CGPDFObjectRef object, int type, void* value);
}