/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSMethodSignature;

import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

class NSMethodSignature : NSObject
{
	mixin ObjcWrap;

	static NSMethodSignature signatureWithObjCTypes (char* types)
	{
		return invokeObjcSelfClass!(NSMethodSignature, "signatureWithObjCTypes:", char*)(typesreturn result is this.objcObject ? this : (result !is null ? new NSMethodSignature(result) : null);	}

	NSUInteger numberOfArguments ()
	{
		return invokeObjcSelf!(NSUInteger, "numberOfArguments");
	}

	char* getArgumentTypeAtIndex (NSUInteger idx)
	{
		return invokeObjcSelf!(char*, "getArgumentTypeAtIndex:", NSUInteger)(idx);
	}

	NSUInteger frameLength ()
	{
		return invokeObjcSelf!(NSUInteger, "frameLength");
	}

	bool isOneway ()
	{
		return invokeObjcSelf!(bool, "isOneway");
	}

	char* methodReturnType ()
	{
		return invokeObjcSelf!(char*, "methodReturnType");
	}

	NSUInteger methodReturnLength ()
	{
		return invokeObjcSelf!(NSUInteger, "methodReturnLength");
	}
}

